-- CPU team constants
local cpu_team = 5
local cpu_resource_period = 10

-- CPU team state data
local cpu_setup = false
local cpu_resource_next = 0

-- set CPU team as AI-controlled
SetAIControl(cpu_team, true)

function Save()
   return cpu_setup, cpu_resource_next
end

function Load(...)
   cpu_setup, cpu_resource_next = ...
end

function Update ()
   local t = GetTime();
   
   if not cpu_setup then
      -- set up the CPU team
      SetAIP("clausmpi.aip", 5)
      cpu_resource_next = t + cpu_resource_period
      cpu_setup = true
   end
   if t > cpu_resource_next then
      -- keep resources topped up
      if (GetScrap(cpu_team) < 20) then AddScrap(cpu_team, 10) end
      cpu_resource_next = cpu_resource_next + cpu_resource_period
   end
Ally (1, 2)
Ally (1, 3)
Ally (1, 4)
Ally (2, 1)
Ally (2, 3)
Ally (2, 4)
Ally (3, 1)
Ally (3, 2)
Ally (3, 4)
Ally (4, 1)
Ally (4, 2)
Ally (4, 3)
UnAlly (5, 1)
UnAlly (5, 2)
UnAlly (5, 3)
UnAlly (5, 4)
UnAlly (1, 5)
UnAlly (2, 5)
UnAlly (3, 5)
UnAlly (4, 5)
	end
