require "math"
local mission_won=false
local mission_lost=false
local startup_done=false
local goalb=false
local goalc=false
local goald=false

local player1fact=false
local player2fact=false
local player3fact=false

--Wave Spawn Timer Vars
local wave_period=200.0
local wave_timer=0.0
--Resupply Enemy Production Vars
local resupply_period=360.0
local resupply_timer=0.0
local topoff_period=10.0
local topoff_timer=0.0
--local cam_time=0.0
--local NextSecond=99999.0

local nsdfrecy=nil
local nsdffact=nil
local player=nil


local apcTable = {}
local p1furyTable = {}
local p2furyTable = {}
local p3furyTable = {}


function AddObject(h)  
    if GetTeamNum(h) == 5 and IsOdf(h,"avapc") then
        for i = 1, # apcTable do
          if not IsAlive(apcTable[i]) then
             table.remove(apcTable, i)
          end
        end
        table.insert(apcTable, h)
    end  
    if GetTeamNum(h) == 1 and IsOdf(h,"svsavomp") then
        for i = 1, # p1furyTable do
          if not IsAlive(p1furyTable[i]) then
             table.remove(p1furyTable, i)
          end
        end
        table.insert(p1furyTable, h)
    end  
    if GetTeamNum(h) == 2 and IsOdf(h,"svsavomp") then
        for i = 1, # p2furyTable do
          if not IsAlive(p2furyTable[i]) then
             table.remove(p2furyTable, i)
          end
        end
        table.insert(p2furyTable, h)
    end 
    if GetTeamNum(h) == 3 and IsOdf(h,"svsavomp") then
        for i = 1, # p3furyTable do
          if not IsAlive(p3furyTable[i]) then
             table.remove(p3furyTable, i)
          end
        end
        table.insert(p3furyTable, h)
    end 
end                   




SetAIControl(5, true)

function Update ()
    SetAIP("unleampi.aip", 5) 
    Ally (1, 2)
    Ally (1, 3)
    Ally (1, 4)
    Ally (2, 1)
    Ally (2, 3)
    Ally (2, 4)
    Ally (3, 1)
    Ally (3, 2)
    Ally (3, 4)
    Ally (4, 1)
    Ally (4, 2)
    Ally (4, 3)
    UnAlly (5, 1)
    UnAlly (5, 2)
    UnAlly (5, 3)
    UnAlly (5, 4)
    UnAlly (1, 5)
    UnAlly (2, 5)
    UnAlly (3, 5)
    UnAlly (4, 5)
    player=GetPlayerHandle()
    nsdfrecy = GetHandle("avrecy0_recycler")
    nsdffact = GetHandle("avmuf0_factory")
    
    for i = 1, # apcTable do
          if IsAlive(apcTable[i]) and GetDistance(apcTable[i],GetNearestEnemy(apcTable[i]))<100.0 and not IsDeployed(apcTable[i]) then
                Deploy(apcTable[i])
          end
    end  
	if resupply_timer<resupply_period then
        resupply_timer = resupply_timer + 0.0167
        else
        resupply_timer = 0.0
        AddPilot (5, 20) 
        AddScrap (5, 250)
        --SetTeamNum (p1furyTable[math.random(# p1furyTable)], 6)
        --SetTeamNum (p2furyTable[math.random(# p2furyTable)], 6)
        --SetTeamNum (p3furyTable[math.random(# p3furyTable)], 6)
        if IsAlive(p1furyTable[1]) then
            SetTeamNum (p1furyTable[math.random(# p1furyTable)], 6)
        end
        if IsAlive(p2furyTable[1]) then
            SetTeamNum (p2furyTable[math.random(# p2furyTable)], 6)
        end
        if IsAlive(p3furyTable[1]) then
            SetTeamNum (p3furyTable[math.random(# p3furyTable)], 6)
        end
    end
    
    if topoff_timer<topoff_period then
        topoff_timer = topoff_timer + 0.0167
        else
        topoff_timer = 0.0
        if (GetScrap(5) < 20) then AddScrap(5, 1) end
        if (GetPilot(5) < 5) then AddPilot(5, 1) end
    end
  
    if not player1fact and GetTeamNum(player)==1 then
        if IsOdf(player,"svtank") or IsOdf(player,"svfimp") or IsOdf(player,"ssuser") or 
            IsOdf(player,"svwamp") or IsOdf(player,"svhraz") or IsOdf(player,"svtump") or 
             IsOdf(player,"svltnk") or IsOdf(player,"svrckt") then
           BuildObject("svmuffmp",1,player)
           player1fact=true
        end
    end
    if not player2fact and GetTeamNum(player)==2  then
        if IsOdf(player,"svtank") or IsOdf(player,"svfimp") or IsOdf(player,"ssuser") or 
            IsOdf(player,"svwamp") or IsOdf(player,"svhraz") or IsOdf(player,"svtump") or 
             IsOdf(player,"svltnk") or IsOdf(player,"svrckt") then
           BuildObject("svmuffmp",2,player)
           player2fact=true
        end
    end
    if not player3fact and GetTeamNum(player)==3  then
        if IsOdf(player,"svtank") or IsOdf(player,"svfimp") or IsOdf(player,"ssuser") or 
            IsOdf(player,"svwamp") or IsOdf(player,"svhraz") or IsOdf(player,"svtump") or 
             IsOdf(player,"svltnk") or IsOdf(player,"svrckt") then
           BuildObject("svmuffmp",3,player)
           player3fact=true
        end
    end
    
  
    if mission_won and IsAudioMessageDone(audmsg) then
            SucceedMission(GetTime(),"unleashdw.des")
    end
    
    if mission_lost and IsAudioMessageDone(audmsg) then
            FailMission(GetTime(),"unleashdf.des")
    end
end


