--[[

	BATTLEZONE 1.5 INSTALLER
	Firestorm MPI Lua Script
	Created by blue banana
	Version 1.1

]]--

local aiTeam = 5
SetAIControl(aiTeam, true)
local started = false

function Update ()
	-- STARTUP PROCESS
	if not started then

		if IsHosting() then
			SetAIP("firestrm.aip", aiTeam)
			AddScrap(aiTeam, 32)
		end
		
		AddObjective("firestrm.otf", "WHITE")

		for i = 1, 3 do
			for j = 1, 3 do
				Ally(i, j)
				Ally(j, i)
				UnAlly(i, aiTeam)
				UnAlly(aiTeam, j)
			end
		end
		LockAllies(true)

		started = true
	end

	if IsHosting() then
		if GetPilot(aiTeam) <= 3 then
			AddPilot(aiTeam, 5)
		end
		if GetScrap(aiTeam) <= 8 then
			AddScrap(aiTeam, 14)
		end
	end
end

function AddPlayer(id, name, team)
	DisplayMessage(name.." has entered the game!")
end