-- Earthquake effect
StartEarthquake(3)

-- AI team
local AIteam = 9

-- Fury unit ODFs
local AirFury = "hvsav"
local GroundFury = "hvsat"

-- Eight handles to track eight furies
local Fury1 = nil
local Fury2 = nil
local Fury3 = nil
local Fury4 = nil
local Fury5 = nil
local Fury6 = nil
local Fury7 = nil
local Fury8 = nil

-- Patrol Path (arbitrary path to patrol)
local PatrolPath = "patrol_path"

-- Set looping path for continuous patrolling
SetPathLoop("patrol_path")

-- Eight-Point path (Fury Spawn Points)
local SpawnPoints = "spawn_path"


function Update()
    --Spawn furies and have them patrol the area, instantly replacing destroyed furies
    if IsHosting() then
        if not IsAlive(Fury1) then
            Fury1 = BuildObject(AirFury, AIteam, SpawnPoints, 1)
            Patrol(Fury1, PatrolPath, 1)
        end
        if not IsAlive(Fury2) then
            Fury2 = BuildObject(GroundFury, AIteam, SpawnPoints, 2)
            Patrol(Fury2, PatrolPath, 1)
        end
        if not IsAlive(Fury3) then
            Fury3 = BuildObject(AirFury, AIteam, SpawnPoints, 3)
            Patrol(Fury3, PatrolPath, 1)
        end
        if not IsAlive(Fury4) then
            Fury4 = BuildObject(GroundFury, AIteam, SpawnPoints, 4)
            Patrol(Fury4, PatrolPath, 1)
        end
        if not IsAlive(Fury5) then
            Fury5 = BuildObject(AirFury, AIteam, SpawnPoints, 5)
            Patrol(Fury5, PatrolPath, 1)
        end
        if not IsAlive(Fury6) then
            Fury6 = BuildObject(GroundFury, AIteam, SpawnPoints, 6)
            Patrol(Fury6, PatrolPath, 1)
        end
        if not IsAlive(Fury7) then
            Fury7 = BuildObject(AirFury, AIteam, SpawnPoints, 7)
            Patrol(Fury7, PatrolPath, 1)
        end
        if not IsAlive(Fury8) then
            Fury8 = BuildObject(GroundFury, AIteam, SpawnPoints, 8)
            Patrol(Fury8, PatrolPath, 1)
        end
    end
end