local camera1=false
local camera2=false
local camera3=false
local found=false
local found2=false
local start_done=false
local patrol1=false
local message1=false
local message2=false
local message3=false
local message4=false
local message5=false
local mission_won=false
local mission_lost=false
local last_wave_time=99999.0
local wave_timer=0.0
local cam_time=0.0
local NextSecond=99999.0
local recycler=nil
local bhandle=nil
local bhome=nil
local bscav=nil
local scav2=nil
local bplayer=nil
local bgoal=nil
local bscout=nil
local lander=nil
local dummy=nil
local bhandle2=nil
local audmsg=0

function Save()
	return 
		-- bools
		camera1,camera2,camera3,found,found2,start_done,patrol1,message1,message2,message3,message4,message5,mission_won,mission_lost,
		-- floats
		last_wave_time,wave_timer,cam_time,NextSecond,
		-- handles
		recycler,bhandle,bhome,bscav,scav2,bplayer,bgoal,bscout,lander,dummy,bhandle2,
		-- ints
		audmsg
end

function Load(...)
	if select('#', ...) > 0 then
		-- bools
		camera1,camera2,camera3,found,found2,start_done,patrol1,message1,message2,message3,message4,message5,mission_won,mission_lost,
		-- floats
		last_wave_time,wave_timer,cam_time,NextSecond,
		-- handles
		recycler,bhandle,bhome,bscav,scav2,bplayer,bgoal,bscout,lander,dummy,bhandle2,
		-- ints
		audmsg
		= ...
	end
end

function PostLoad()
end

function AddObject(h)
	if GetTeamNum(h) == 1 and IsOdf(h, "avscav") and bscav == nil then
		found = true
		bscav = h	
	end
	if GetTeamNum(h) == 2 and IsOdf(h, "svfigh") then
		if not found2 then
			found2 = true
			bscout = h
			Goto(bscout,"patrol1",0)
			SetObjectiveOn(bscout)
		else
			if GetDistance(bscav,bgoal)<200.0 then
				Attack(h,bscav)
			else
				Goto(h,"patrol2",0) -- attack scrap field
			end
		end
	end
end

function Update ()

	bplayer=GetPlayerHandle()
	if not start_done then
		SetPilot(1,2)
		SetScrap(1,5)
		SetAIP("misn02.aip")
		
		dummy = GetHandle("fake_player")
		lander = GetHandle("avland0_wingman")
		bhandle = GetHandle("sscr_171_scrap")
		bhome = GetHandle("abcomm1_i76building")
		recycler = GetHandle("avrecy-1_recycler")
		bgoal = GetHandle("apscrap-1_camerapod")
		bhandle2 = GetHandle("sscr_176_scrap")
		SetUserTarget(bgoal)
		start_done=true
		camera1=true
		cam_time=GetTime()+30.0
		CameraReady()
		audmsg = AudioMessage("misn0230.wav")
	end

	if camera1 then
		if CameraPath("fixcam",1200,250,lander) or CameraCancelled() or IsAudioMessageDone(audmsg) then
			camera1 = false
			cam_time=GetTime()+10.0
			camera2 = true
		end
	end
	
	if camera2  then
		camera2=false
		camera3=true
		Goto(dummy,"player_path")
		cam_time=GetTime()+25.0
	end
	
	if camera3 then
		if CameraPath("zoomcam",1200,800,dummy) or IsAudioMessageDone(audmsg) or CameraCancelled() then
			camera3=false
			cam_time=99999.0
			CameraFinish()
			RemoveObject(dummy)
			StopAudioMessage(audmsg)
			audmsg = 0
			AudioMessage("misn0224.wav")
			wave_timer=GetTime()+30.0
			AddObjective("misn02b1.otf", "WHITE")
		end
	end
	
	if not patrol1 and found and GetDistance(bhandle,bscav)<75.0 then
		BuildObject("svfigh", 2, "spawn1")
		AudioMessage("misn0233.wav")
		message1=true
		patrol1=true
		if not message4 and found2 then
			message4=true
		end
	end
	
	if not message4 and found2 then
		-- this is in case the AddObject is called in
		-- a different frame than the BuildObject() above
		message4=true
	end
	
	if message4 and not message5 and GetDistance(bscav,bhandle2)<200.0 then
		BuildObject("svfigh",2,"spawn2")
		message5=true
		wave_timer=GetTime()+30.0
	end
	
	if message5 and GetTime()>wave_timer then
		BuildObject("svfigh",2,"spawn2")
		wave_timer=GetTime()+45.0
	end
	
	if message1 and message5 and not message2 and GetLastEnemyShot(bscav)>0 then
		-- send the scav home
		Follow(bscav, bhome, 0)
		ClearObjectives()
		AddObjective("misn02b2.otf", "WHITE")
		-- "Commander, our instruments show that you are heavily outnumbered..."
		AudioMessage("misn0225.wav")
		SetUserTarget(GetHandle("apbase-1_camerapod"))
		message2=true
	end
	
	if not mission_lost and (
		not IsAlive(bplayer) or
		(bscav and not IsAlive(bscav)) or 
		(message3 and not IsAlive(scav2)) or
		not IsAlive(bhome) or
		not IsAlive(recycler)
        ) then
		-- you or the scav is dead
		ClearObjectives()
		AddObjective("misn02b4.otf","RED")
		-- "Eagle's Nest 1 is being overrun.  Our forces are surrendering..."
		audmsg=AudioMessage("misn0227.wav")
		mission_lost=true
	end
	
	if mission_lost and IsAudioMessageDone(audmsg) then
		FailMission(GetTime(),"misn02l1.des")
	end
	
	if  not message3 and message1 and message4 and IsAlive(bplayer) and GetDistance(bhome,bscav)<300 then
		-- now rescue the second scavenger
		Follow(bscav,bhome)
		wave_timer=GetTime()+45.0
		scav2=BuildObject("avscav",1,"spawn3")
		Retreat(scav2,"retreat")
		SetObjectiveOn(scav2)
		AudioMessage("misn0228.wav")
		last_wave_time=GetTime()+10.0
		NextSecond=GetTime()+1.0
		message3=true
	end
	
	if IsAlive(bscav) and message3 and GetTime()>NextSecond then
		AddHealth(bscav,200.0)
		NextSecond=GetTime()+1.0
	end
	
	if last_wave_time<GetTime() then
		local sid=BuildObject("svfigh",2,"spawn4")
		Attack(sid,scav2)
		last_wave_time=99999.0
	end
	
	if not mission_won and message3 and GetDistance(bhome,scav2)<200.0 then
		ClearObjectives()
		AddObjective("misn02b3.otf", "GREEN")
		AddHealth(bscav,1000)
		AddHealth(scav2,1000)
	
		audmsg=AudioMessage("misn0234.wav")
		mission_won=true
	end
	
	if mission_won and IsAudioMessageDone(audmsg) then
		SucceedMission(GetTime(),"misn02w1.des")
	end

end
